//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  DeepSkyBlue
#property indicator_color2  DeepSkyBlue
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  DimGray
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_level1  0
#property indicator_levelcolor DimGray

//
//
//
//
//

extern int Length = 25;
extern int Price  = PRICE_CLOSE;

double osc[];
double oscuu[];
double oscud[];
double oscdd[];
double oscdu[];
double price[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,oscuu); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,oscud); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,oscdd); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,oscdu); SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,osc);
      SetIndexBuffer(5,price);
      SetIndexBuffer(6,slope);
   IndicatorShortName("Simple oscillator ("+Length+"%)");
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      price[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      osc[i]   = 0;

            double weight = (Length-1.0)/2.0;  for (int k=0; k<Length; k++, weight -=1) osc[i] += price[i+k]*weight;

            //
            //
            //
            //
            //
            
            oscuu[i] = EMPTY_VALUE;
            oscud[i] = EMPTY_VALUE;
            oscdd[i] = EMPTY_VALUE;
            oscdu[i] = EMPTY_VALUE;
            slope[i] = slope[i+1];
               if (osc[i]>osc[i+1]) slope[i]= 1;
               if (osc[i]<osc[i+1]) slope[i]=-1;
               if (osc[i]>0 && slope[i]== 1) oscuu[i] = osc[i];
               if (osc[i]>0 && slope[i]==-1) oscud[i] = osc[i];
               if (osc[i]<0 && slope[i]==-1) oscdd[i] = osc[i];
               if (osc[i]<0 && slope[i]== 1) oscdu[i] = osc[i];
   }
   return(0);
}

